<template>
  <div>
    <b-card-group deck class="mb-5" v-if="clientStore.infoClient">
      <b-card header-tag="header">
        <template #header>
          <h5 class="mb-0">Données personnelles</h5>
        </template>
        <b-card-text>
          {{ clientStore.infoClient.civilite }} &nbsp; {{ clientStore.infoClient.name }} &nbsp; {{ clientStore.infoClient.firstName }}<br />
          <font-awesome-icon icon="envelope" /> {{ clientStore.infoClient.email }}<br />
          <font-awesome-icon icon="phone-alt" /> {{ clientStore.infoClient.phoneNumber }}
        </b-card-text>
        <b-button href="#" variant="outline-default"><font-awesome-icon icon="edit" /> Modifier</b-button>
      </b-card>

      <b-card header-tag="header" v-if="clientStore.infoClient.delivery">
        <template #header>
          <h5 class="mb-0">Adresse de livraison</h5>
        </template>
        <b-card-text>
          {{ clientStore.infoClient.delivery[0].street }}<br />
          {{ clientStore.infoClient.delivery[0].postalCode }}
          {{ clientStore.infoClient.delivery[0].city }}<br />
          {{ clientStore.infoClient.delivery[0].country }}<br />
        </b-card-text>
        <!-- <b-button href="#" variant="outline-default"><font-awesome-icon icon="edit" /> Changer l'adresse</b-button> -->
        <router-link :to="{ path: 'compte-client', query: { action: 'adresse', pageReturn: 'panier' } }">
          <b-button variant="outline-default"><font-awesome-icon icon="edit" /> Changer l'adresse</b-button>
        </router-link>
      </b-card>
    </b-card-group>

    <h3 class="h4 mb-3">Sélectionner un mode de livraison</h3>

    <b-form-group>
      <b-card-group deck class="my-3">
        <b-card class="text-center" v-for="(delivery, idx) in availablesDelivery" :key="delivery.id">
          <b-card-text>
            <b-form-radio name="radios-delivery" :value="idx" v-model="idxSelectedDelivery" @change="retrieveFP(delivery)">{{ delivery.libelle }}</b-form-radio>
          </b-card-text>
        </b-card>
      </b-card-group>

      <b-card v-if="availablesDelivery[idxSelectedDelivery]" :header="availablesDelivery[idxSelectedDelivery].libelle" class="text-center">
        <b-card-text>
          Montant des frais de port choisis: {{ cartStore.delivery.cost | euro }}<br />
          <strong v-if="availablesDelivery[idxSelectedDelivery].zone == 'pays'">Pays déservis :</strong> <span v-if="availablesDelivery[idxSelectedDelivery].zone == 'pays'">{{ availablesDelivery[idxSelectedDelivery].pays }}</span>
        </b-card-text>
        <b-card-text class="lh-sm" v-html="availablesDelivery[idxSelectedDelivery].description"> </b-card-text>
      </b-card>
    </b-form-group>
  </div>
</template>
<script>
import { mapState, mapActions } from "vuex";
import configFPJson from "@/config-data/config-fp.json";
import configTarifsFPJson from "@/config-data/config-fp-tarifs.json";
export default {
  computed: {
    // récupération infos client
    ...mapState({
      clientStore: state => state.clientStore,
      cartStore: state => state.cartStore
    })
  },
  mounted: function() {
    this.loadConfigFP();
  },
  data() {
    return {
      configFPJson,
      configTarifsFPJson,
      availablesDelivery: [],
      idxSelectedDelivery: null,

      clientPays: "",

      // variables client temporaire
      infoClient: {
        livraison: {
          firstName: "John",
          name: "Doe",
          address: "8 impasse Saint-Nizier",
          city: "Lyon",
          cp: "69002",
          country: "France"
        }
      }
    };
  },
  methods: {
    checkPaysClient() {
      // check poids du caddie
      if (
        this.clientStore.infoClient.delivery[0].city !== "" &&
        this.clientStore.infoClient.delivery[0].country !== "" &&
        this.clientStore.infoClient.delivery[0].postalCode !== "" &&
        this.clientStore.infoClient.delivery[0].street !== "" &&
        this.clientStore.infoClient.name !== "" &&
        this.clientStore.infoClient.firstName !== ""
      ) {
        this.clientPays = this.clientStore.infoClient.delivery[0].country;
      }
      console.log("eee");
    },
    loadConfigFP() {
      if (this.clientStore.isAuthenticated) {
        // TODO: MODIF INT2GRATION INFOS CLIENT
        // this.$store.dispatch("initClient", { infoClient: this.infoClient });
        this.checkPaysClient();
        this.configFPJson = this.configFPJson.filter(typeFP => typeFP.actif == true);
        // construct list of delivery
        this.configFPJson.forEach(typeFP => {
          typeFP.modes.forEach(modeFP => {
            if (modeFP.actif == true) {
              // ajout des livraisons par pays
              if (modeFP.zone == "pays") {
                if (modeFP.pays.includes(this.clientPays)) {
                  modeFP.type = typeFP.type;
                  this.availablesDelivery.push(modeFP);
                }
              }
              // ajout des livraisons sans zone
              if (modeFP.zone == "") {
                modeFP.type = typeFP.type;
                this.availablesDelivery.push(modeFP);
              }
            }
          });
        });
      }
    },
    retrieveFP(delivery) {
      this.$store.dispatch("setDelivery", { delivery: delivery });
    }
    // retrieveFP(delivery) {
    //   console.log("delivery", delivery);

    //   let _tarifsFP = this.configTarifsFPJson.filter(tarif => {
    //     return tarif.type.toString() == delivery.type.toString();
    //   });

    //   _tarifsFP = _tarifsFP[0].tarifs.filter(zoneTarif => {
    //     return zoneTarif.libelle.toString() == delivery.libelle.toString();
    //   });
    //   _tarifsFP = _tarifsFP[0];

    //   // init payload  for cartStore
    //   let infoDelivery = {
    //     cost: 0,
    //     name: "Non défini"
    //   };

    //   let _franco = _tarifsFP.franco;
    //   if (delivery.zone == "pays" && delivery.calcul == "poids") {
    //     // TRAITEMENT LIVRAISON TYPE COLISSIMO
    //     _tarifsFP = _tarifsFP.poids.filter(weight => {
    //       return parseFloat(this.cartStore.cartWeight) >= parseFloat(weight.min) && parseFloat(this.cartStore.cartWeight) < parseFloat(weight.max);
    //     });

    //     if (_tarifsFP.length > 0) {
    //       _tarifsFP = _tarifsFP[0].prix;
    //       infoDelivery.cost = _tarifsFP;
    //       infoDelivery.name = delivery.libelle;
    //     }
    //   } else if (delivery.calcul == "") {
    //     // TRAITEMENT LIVRAISON SANS CALCUL
    //     infoDelivery.cost = _tarifsFP.prix;
    //     infoDelivery.name = delivery.libelle;
    //   } else if (delivery.zone == "cp") {
    //     // TRAITEMENT LIVRAISON CODE POSTAUX
    //   } else if (delivery.zone == "transporteur") {
    //     // TRAITEMENT LIVRAISON TRANSPORTEURS
    //   } else if (delivery.zone == "special") {
    //     // TRAITEMENT CALCUL SPECIAL
    //   }

    //   // vérification si franco de port
    //   // if (_franco > 0 && parseFloat(this.cartStore.totalHT) > parseFloat(_franco)) {
    //   //   infoDelivery.cost = 0;
    //   // }
    //   infoDelivery.franco = _franco;

    //   this.$store.dispatch("setDelivery", { infoDelivery: infoDelivery });
    // }
  }
};
</script>
